"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const index_1 = require("../index");
const notifications_1 = require("../../lib/notifications");
const index_2 = require("./index");
const i18n_1 = tslib_1.__importDefault(require("src/locales/i18n"));
const strings_1 = tslib_1.__importDefault(require("../../locales/strings"));
const recovery_1 = require("../recovery");
exports.checkRecoverySetup = (dispatch, getState) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    yield dispatch(index_1.accountActions.hasExternalCredentials);
    const { settings: { seedPhraseSaved }, account: { claims: { hasExternalCredentials }, }, } = getState();
    if (!seedPhraseSaved && hasExternalCredentials) {
        const notification = notifications_1.createStickyNotification({
            title: i18n_1.default.t(strings_1.default.CONFIRMATION_IS_NOT_COMPLETE),
            message: i18n_1.default.t(strings_1.default.YOUR_DATA_MAY_BE_LOST_BECAUSE_YOU_DID_NOT_CONFIRM_THE_SEED_PHRASE_WE_ADVISE_YOU_TO_COMPLETE_THE_REGISTRATION),
            interact: {
                label: strings_1.default.CONFIRM,
                onInteract: () => {
                    dispatch(recovery_1.showSeedPhrase());
                    return true;
                },
            },
        });
        return dispatch(index_2.scheduleNotification(notification));
    }
});
