"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const softwareProvider_1 = require("jolocom-lib/js/vaultedKeyProvider/softwareProvider");
const index_1 = require("./index");
const routeList_1 = require("../routeList");
const notifications_1 = require("./notifications");
exports.showSeedPhrase = () => (dispatch, getState, backendMiddleware) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    const encryptedSeed = yield backendMiddleware.storageLib.get.encryptedSeed();
    if (!encryptedSeed) {
        throw new Error('Can not retrieve Seed from database');
    }
    // TODO create vault from encrypted Seed
    const pass = yield backendMiddleware.keyChainLib.getPassword();
    const vault = new softwareProvider_1.SoftwareKeyProvider(Buffer.from(encryptedSeed, 'hex'));
    const mnemonic = vault.getMnemonic(pass);
    return dispatch(index_1.navigationActions.navigate({
        routeName: routeList_1.routeList.SeedPhrase,
        params: { mnemonic },
    }));
});
exports.setSeedPhraseSaved = () => (dispatch, getState, backendMiddleware) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    yield backendMiddleware.storageLib.store.setting('seedPhraseSaved', true);
    // TODO: find sticky by id from queue, not active
    const { notifications: { active: stickyNotification }, } = getState();
    if (stickyNotification)
        dispatch(notifications_1.removeNotification(stickyNotification));
    return dispatch({
        type: 'SET_SEED_PHRASE_SAVED',
    });
});
