"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const actions_1 = require("src/actions/");
const routeList_1 = require("src/routeList");
const loading = tslib_1.__importStar(require("src/actions/registration/loadingStages"));
const account_1 = require("src/actions/account");
const navigation_1 = require("../navigation");
const recovery_1 = require("../recovery");
exports.setLoadingMsg = (loadingMsg) => ({
    type: 'SET_LOADING_MSG',
    value: loadingMsg,
});
exports.setIsRegistering = (value) => ({
    type: 'SET_IS_REGISTERING',
    value,
});
exports.createIdentity = (encodedEntropy) => (dispatch, getState, backendMiddleware) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    dispatch(actions_1.navigationActions.navigate({
        routeName: routeList_1.routeList.RegistrationProgress,
    }));
    const isRegistering = getState().registration.loading.isRegistering;
    if (isRegistering)
        return;
    dispatch(exports.setIsRegistering(true));
    dispatch(exports.setLoadingMsg(loading.loadingStages[0]));
    yield backendMiddleware.createKeyProvider(encodedEntropy);
    dispatch(exports.setLoadingMsg(loading.loadingStages[1]));
    yield backendMiddleware.fuelKeyWithEther();
    dispatch(exports.setLoadingMsg(loading.loadingStages[2]));
    const identity = yield backendMiddleware.createIdentity();
    dispatch(account_1.setDid(identity.did));
    dispatch(exports.setLoadingMsg(loading.loadingStages[3]));
    dispatch(exports.setIsRegistering(false));
    return dispatch(navigation_1.navigatorResetHome());
});
exports.recoverIdentity = (mnemonic) => (dispatch, getState, backendMiddleware) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    dispatch(exports.setIsRegistering(true));
    let identity;
    try {
        identity = yield backendMiddleware.recoverIdentity(mnemonic);
    }
    catch (e) {
        return dispatch(exports.setIsRegistering(false));
    }
    dispatch(account_1.setDid(identity.did));
    dispatch(recovery_1.setSeedPhraseSaved());
    dispatch(exports.setIsRegistering(false));
    return dispatch(navigation_1.navigatorResetHome());
});
