"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CredentialTypes;
(function (CredentialTypes) {
    CredentialTypes["Email"] = "Email";
    CredentialTypes["MobilePhone"] = "Mobile Phone";
    CredentialTypes["Name"] = "Name";
    CredentialTypes["PostalAddress"] = "Postal Address";
})(CredentialTypes = exports.CredentialTypes || (exports.CredentialTypes = {}));
var Categories;
(function (Categories) {
    Categories["Personal"] = "Personal";
    Categories["Contact"] = "Contact";
    Categories["Other"] = "Other";
})(Categories = exports.Categories || (exports.Categories = {}));
exports.uiCredentialTypeByType = {
    ProofOfEmailCredential: CredentialTypes.Email,
    ProofOfMobilePhoneNumberCredential: CredentialTypes.MobilePhone,
    ProofOfNameCredential: CredentialTypes.Name,
    ProofOfPostalAddressCredential: CredentialTypes.PostalAddress,
};
exports.uiCategoryByCredentialType = {
    Contact: [
        CredentialTypes.Email,
        CredentialTypes.MobilePhone,
        CredentialTypes.PostalAddress,
    ],
    Personal: [CredentialTypes.Name],
};
exports.defaultUiCategories = Object.keys(exports.uiCategoryByCredentialType);
