"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const sjcl = tslib_1.__importStar(require("sjcl"));
class EntropyGenerator {
    constructor() {
        this.generator = new sjcl.prng(10);
    }
    addFromDelta(d) {
        this.generator.addEntropy(d, 1, 'user');
    }
    getProgress() {
        return this.generator.getProgress();
    }
    /**
     * Once the generator is ready, it can be used to generate a random buffer
     * @param wordCount - Amount of random words to generate (1 word - 4 bytes)
     * @returns Hex string encoding wordCount * 4 bytes random bytes
     */
    generateRandomString(wordCount) {
        const intArray = new Int32Array(this.generator.randomWords(wordCount));
        const buf = Buffer.from(intArray.buffer);
        return buf.toString('hex');
    }
}
exports.EntropyGenerator = EntropyGenerator;
