"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const node_fetch_1 = tslib_1.__importDefault(require("node-fetch"));
var HttpMethods;
(function (HttpMethods) {
    HttpMethods["GET"] = "GET";
    HttpMethods["POST"] = "POST";
    HttpMethods["HEAD"] = "HEAD";
})(HttpMethods || (HttpMethods = {}));
exports.httpAgent = {
    getRequest: (endpoint) => node_fetch_1.default(endpoint, {
        method: HttpMethods.GET,
    }).then(res => res.json()),
    headRequest(endpoint) {
        return node_fetch_1.default(endpoint, {
            method: HttpMethods.HEAD,
        }).then(res => res.json());
    },
    postRequest(endpoint, headers = {}, data) {
        return node_fetch_1.default(endpoint, {
            method: HttpMethods.POST,
            headers,
            body: typeof data === 'string' ? data : JSON.stringify(data),
        }).then(res => res.json());
    },
};
