"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = require("crypto");
const createNotificationFactory = (template) => (overrides) => (Object.assign({ id: crypto_1.randomBytes(4).toString('hex') }, template, overrides));
var NotificationFilter;
(function (NotificationFilter) {
    NotificationFilter[NotificationFilter["none"] = 0] = "none";
    NotificationFilter[NotificationFilter["all"] = 1] = "all";
    NotificationFilter[NotificationFilter["onlyDismissible"] = 2] = "onlyDismissible";
})(NotificationFilter = exports.NotificationFilter || (exports.NotificationFilter = {}));
var NotificationType;
(function (NotificationType) {
    NotificationType["error"] = "error";
    NotificationType["info"] = "info";
    NotificationType["warning"] = "warning";
})(NotificationType = exports.NotificationType || (exports.NotificationType = {}));
exports.createInfoNotification = createNotificationFactory({
    type: NotificationType.info,
    dismiss: {
        timeout: 3000,
    },
});
exports.createWarningNotification = createNotificationFactory({
    type: NotificationType.warning,
    dismiss: {
        timeout: 3000,
    },
});
exports.createStickyNotification = createNotificationFactory({
    type: NotificationType.info,
    dismiss: false,
});
