"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("jolocom-lib/js/interactionTokens/types");
const sso_1 = require("../../actions/sso");
const authenticationRequest_1 = require("../../actions/sso/authenticationRequest");
const credentialOfferRequest_1 = require("../../actions/sso/credentialOfferRequest");
const paymentRequest_1 = require("../../actions/sso/paymentRequest");
/**
 * @param Metadata should not need to be passed to credential receive because it comes from cred Offer
 * Furthermore, this only needs to be defined for requests
 */
exports.interactionHandlers = {
    [types_1.InteractionType.Authentication]: (interactionToken, isDeepLinkInteraction) => authenticationRequest_1.consumeAuthenticationRequest(interactionToken, isDeepLinkInteraction),
    [types_1.InteractionType.CredentialRequest]: (interactionToken, isDeepLinkInteraction) => sso_1.consumeCredentialRequest(interactionToken, isDeepLinkInteraction),
    [types_1.InteractionType.CredentialOfferRequest]: (interactionToken, isDeepLinkInteraction) => credentialOfferRequest_1.consumeCredentialOfferRequest(interactionToken, isDeepLinkInteraction),
    [types_1.InteractionType.PaymentRequest]: (interactionToken, isDeepLinkInteraction) => paymentRequest_1.consumePaymentRequest(interactionToken, isDeepLinkInteraction),
};
