"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jolocom_lib_1 = require("jolocom-lib");
const categories_1 = require("./categories");
const react_native_1 = require("react-native");
const ramda_1 = require("ramda");
// this comes from 'react-native-randombytes'
const { RNRandomBytes } = react_native_1.NativeModules;
exports.getClaimMetadataByCredentialType = (type) => {
    const uiType = Object.keys(categories_1.uiCredentialTypeByType).find(item => categories_1.uiCredentialTypeByType[item] === type);
    const relevantType = Object.keys(jolocom_lib_1.claimsMetadata).find(key => jolocom_lib_1.claimsMetadata[key].type[1] === uiType);
    if (!relevantType) {
        throw new Error("Unknown credential type, can't find metadata");
    }
    return jolocom_lib_1.claimsMetadata[relevantType];
};
exports.getUiCredentialTypeByType = (type) => categories_1.uiCredentialTypeByType[type[1]] || exports.prepareLabel(type[1]);
exports.getCredentialUiCategory = ({ credentialType, }) => {
    const uiCategories = Object.keys(categories_1.uiCategoryByCredentialType);
    return (uiCategories.find(uiCategory => categories_1.uiCategoryByCredentialType[uiCategory].some(ramda_1.equals(credentialType))) || categories_1.Categories.Other);
};
exports.prepareLabel = (label) => {
    const words = label.split(/(?=[A-Z0-9])/);
    return words.length > 1 ? words.map(exports.capitalize).join(' ') : exports.capitalize(label);
};
exports.capitalize = (word) => `${word[0].toUpperCase()}${word.slice(1)}`;
exports.compareDates = (date1, date2) => Math.floor((Date.UTC(date2.getFullYear(), date2.getMonth(), date2.getDate()) -
    Date.UTC(date1.getFullYear(), date1.getMonth(), date1.getDate())) /
    (1000 * 60 * 60 * 24));
function generateSecureRandomBytes(length) {
    return new Promise((resolve, reject) => {
        RNRandomBytes.randomBytes(length, (err, bytes) => {
            if (err)
                reject(err);
            else
                resolve(bytes);
        });
    });
}
exports.generateSecureRandomBytes = generateSecureRandomBytes;
