"use strict";
// TODO
// don't load all translations in memory, when we have a lot of translations
// see
// https://github.com/react-native-community/react-native-localize/blob/master/example/src/AsyncExample.js
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const RNLocalize = tslib_1.__importStar(require("react-native-localize"));
const i18n_js_1 = tslib_1.__importDefault(require("i18n-js"));
const de = require('./de.json');
const nl = require('./nl.json');
i18n_js_1.default.defaultLocale = 'en';
i18n_js_1.default.fallbacks = true;
i18n_js_1.default.missingTranslation = scope => scope;
i18n_js_1.default.translations = {
    de,
    nl,
};
exports.locales = ['en', 'de', 'nl'];
const fallback = { languageTag: 'en', isRTL: false };
const { languageTag } = RNLocalize.findBestAvailableLanguage(exports.locales) || fallback;
i18n_js_1.default.locale = languageTag;
const localeSpecificImages = {
    en: {
        '01.jpg': require('src/resources/img/en/01.jpg'),
        '02.jpg': require('src/resources/img/en/02.jpg'),
        '03.jpg': require('src/resources/img/en/03.jpg'),
    },
    de: {
        '01.jpg': require('src/resources/img/de/01.jpg'),
        '02.jpg': require('src/resources/img/de/02.jpg'),
        '03.jpg': require('src/resources/img/de/03.jpg'),
    },
    nl: {
        '01.jpg': require('src/resources/img/nl/01.jpg'),
        '02.jpg': require('src/resources/img/nl/02.jpg'),
        '03.jpg': require('src/resources/img/nl/03.jpg'),
    },
};
exports.getI18nImage = (filename) => {
    const locale = exports.locales.includes(i18n_js_1.default.locale)
        ? i18n_js_1.default.locale
        : i18n_js_1.default.defaultLocale;
    return localeSpecificImages[locale][filename];
};
exports.default = i18n_js_1.default;
