"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ramda_1 = require("ramda");
const notifications_1 = require("src/lib/notifications");
exports.SCHEDULE_NOTIFICATION = 'SCHEDULE_NOTIFICATION';
exports.REMOVE_NOTIFICATION = 'REMOVE_NOTIFICATION';
exports.SET_ACTIVE_NOTIFICATION = 'SET_ACTIVE_NOTIFICATION';
exports.CLEAR_NOTIFICATIONS = 'CLEAR_NOTIFICATIONS';
exports.SET_ACTIVE_FILTER = 'SET_ACTIVE_FILTER';
const initialState = {
    queue: [],
    active: null,
    activeExpiryTs: 0,
    activeFilter: notifications_1.NotificationFilter.all,
};
exports.notificationsReducer = (state = initialState, action) => {
    switch (action.type) {
        case exports.SCHEDULE_NOTIFICATION:
            return Object.assign({}, state, { queue: [...state.queue, action.notification] });
        case exports.REMOVE_NOTIFICATION:
            const queue = ramda_1.reject(notification => notification.id === action.notification.id, state.queue);
            return Object.assign({}, state, { queue });
        case exports.SET_ACTIVE_NOTIFICATION:
            return Object.assign({}, state, { active: action.notification, activeExpiryTs: action.expiry });
        case exports.CLEAR_NOTIFICATIONS:
            return initialState;
        case exports.SET_ACTIVE_FILTER:
            if (state.activeFilter === action.value)
                return state;
            return Object.assign({}, state, { activeFilter: action.value });
        default:
            return state;
    }
};
