"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const redux_1 = require("redux");
const redux_thunk_1 = tslib_1.__importDefault(require("redux-thunk"));
const reducers_1 = require("src/reducers");
const config_1 = tslib_1.__importDefault(require("src/config"));
const backendMiddleware_1 = require("./backendMiddleware");
function initStore() {
    const backendMiddleware = new backendMiddleware_1.BackendMiddleware(config_1.default);
    /*
     * The {} as RootState type assertion:
     * The second argument, "preloadedState" is mandatory, and typed as RootState.
     * We provide an empty object. The store will have the correct default state
     * after all reducers initialise.
     */
    return redux_1.createStore(reducers_1.rootReducer, {}, redux_1.applyMiddleware(redux_thunk_1.default.withExtraArgument(backendMiddleware)));
}
exports.initStore = initStore;
