"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ramda_1 = require("ramda");
const DOC_TYPES = [
    'IdCard',
    'Passport',
    'DrivingLicense',
    'Certificate',
    'EventTicket',
    'Proof Of Driving License Credential',
];
const isIncludedIn = (list) => (element) => ramda_1.includes(element, list);
/** @TODO Housekeeping - We should compare against DOC_TYPES using the `type`
 *    of a credential instead of the `credentialType` (which is formatted for render)
 */
const isDocument = ({ credentialType, renderInfo = {} }) => ramda_1.compose(
// @ts-ignore
ramda_1.or(ramda_1.equals(renderInfo.renderAs, 'document')), isIncludedIn(DOC_TYPES))(credentialType);
exports.getDocumentClaims = (claims) => claims.filter(isDocument);
exports.getNonDocumentClaims = (claims) => claims.filter(ramda_1.complement(isDocument));
